pro Create_New_Log_File, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR_struct
	s_ptr = PTR_struct.PTR_summary
	;
	date_time = SYSTIME()
	mon = ''
	reads, date_time, format='(4x,A3,1x,i2,1x,i2,1x,i2,1x,i2,1x,i4)',mon,day,hh,mm,ss,year
	amon = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"]
	imon = WHERE(mon eq amon[*])
	ymdhm = ulong64(year)*100000000L + ulong64(imon[0]+1)*1000000L + ulong64(day)*10000L + $
			ulong64(hh)*100L + ulong64(mm)
	;
	log_name = 'MST_log_'+STRING(format='(I12.12)',ymdhm)+'.dat'
	log_dir = (*s_ptr).this_dir + PATH_SEP() + 'Analysis_Logs'
	;
	;	check directory exists, if not, create
	;
	result = FILE_TEST(log_dir,/directory)
	if(result eq 0) then FILE_MKDIR, log_dir
	;
	log_path = log_dir + PATH_SEP() + log_name
	openw, lu_log, log_path, /GET_LUN
	printf, lu_log, 'Log file for Mock Star Tool opened at ', SYSTIME()
	print_text, Event, 'Log file for Mock Star Tool opened at '+SYSTIME()
	;
	(*s_ptr).lu_log = lu_log
	(*s_ptr).log_path = log_path
end